Moose::Meta::Attribute::Native::Trait::Hash(3)

NAME
Moose::Meta::Attribute::Native::Trait::Hash - Helper trait for HashRef attributes

VERSION
version 2.0602

SYNOPSIS
  package Stuff;
  use Moose;

  has 'options' => (
      traits    => ['Hash'],
      is        => 'ro',
      isa       => 'HashRef[Str]',
      default   => sub { {} },
      handles   => {
          set_option     => 'set',
          get_option     => 'get',
          has_no_options => 'is_empty',
          num_options    => 'count',
          delete_option  => 'delete',
          option_pairs   => 'kv',
      },
  );

DESCRIPTION
This trait provides native delegation methods for hash references.

PROVIDED METHODS

get($key, $key2, $key3...)
    Returns values from the hash.

    In list context it returns a list of values in the hash for the given keys. In scalar context it returns the value for the last key specified.

    This method requires at least one argument.

set($key => $value, $key2 => $value2...)
    Sets the elements in the hash to the given values. It returns the new values set for each key, in the same order as the keys passed to the method.

    This method requires at least two arguments, and expects an even number of arguments.

delete($key, $key2, $key3...)
    Removes the elements with the given keys.

    In list context it returns a list of values in the hash for the deleted keys. In scalar context it returns the value for the last key specified.

keys
    Returns the list of keys in the hash.

    This method does not accept any arguments.

exists($key)
    Returns true if the given key is present in the hash.

    This method requires a single argument.

defined($key)
    Returns true if the value of a given key is defined.

    This method requires a single argument.

values
    Returns the list of values in the hash.

    This method does not accept any arguments.

kv  Returns the key/value pairs in the hash as an array of array references.

      for my $pair ( $object->option_pairs ) {
          print "$pair->[0] = $pair->[1]\n";
      }

    This method does not accept any arguments.

elements
    Returns the key/value pairs in the hash as a flattened list..

    This method does not accept any arguments.

clear
    Resets the hash to an empty value, like "%hash = ()".

    This method does not accept any arguments.

count
    Returns the number of elements in the hash. Also useful for not empty: "has_options => 'count'".

    This method does not accept any arguments.

is_empty
    If the hash is populated, returns false. Otherwise, returns true.

    This method does not accept any arguments.

accessor($key)
accessor($key, $value)
    If passed one argument, returns the value of the specified key. If passed two arguments, sets the value of the specified key.

    When called as a setter, this method returns the value that was set.

shallow_clone
    This method returns a shallow clone of the hash reference. The return value is a reference to a new hash with the same keys and values. It is shallow because any values that were references in the original will be the same references in the clone.

Note that "each" is deliberately omitted, due to its stateful interaction with the hash iterator. "keys" or "kv" are much safer.

METHODS

meta

BUGS
See "BUGS" in Moose for details on reporting bugs.

AUTHOR
Moose is maintained by the Moose Cabal, along with the help of many contributors. See "CABAL" in Moose and "CONTRIBUTORS" in Moose for details.

COPYRIGHT AND LICENSE
This software is copyright (c) 2012 by Infinity Interactive, Inc..

This is free software; you can redistribute it and/or modify it under the same terms as the Perl 5 programming language system itself.